﻿
Imports FirebirdSql.Data.Firebird

Public Class frmEdit

    Private Sub frmEdit_Load(ByVal sender As System.Object, _
                             ByVal e As System.EventArgs) _
                             Handles MyBase.Load

        ' Controlliamo se il record è nuovo o è un record
        ' già esistente da modificare
        Select Case IdDaModificare

            Case -1 ' record nuovo

                ' Imposto il titolo del form
                Me.Text = "Inserimento di un nuovo record"

            Case Else ' record da modificare

                ' prelevo quindi i campi del record avente l'id in
                ' questione e precompilo i campi del form

                ' Definisco la Query di estrazione
                Dim Query As String = "SELECT * FROM indirizzi WHERE ID=" & IdDaModificare

                ' Apro la connessione al database
                Dim Conn As New FbConnection(Str_Co)
                Conn.Open()

                ' Definisco un comando da eseguire sul database
                Dim Cmd As New FbCommand(Query, Conn)

                ' Definisco un datareade
                Dim Dr As FbDataReader = Cmd.ExecuteReader

                ' Effettuo la lettura dei dati
                Dr.Read()

                ' Riporto i risultati della lettura nelle textbox
                txtNome.Text = Dr("NOME")
                txtCognome.Text = Dr("COGNOME")
                txtEmail.Text = Dr("EMAIL")

                ' Chiudo la connessione e rilascio le risorse
                Cmd.Dispose()
                Conn.Close()

                ' Imposto il titolo del form
                Me.Text = "Modifica dati: " & txtCognome.Text & " " & txtNome.Text

        End Select

    End Sub

    Private Sub frmEdit_Shown(ByVal sender As Object, _
                              ByVal e As System.EventArgs) _
                              Handles Me.Shown

        ' L'evento Shown del form si verifica dopo che è stato caricato (Load)
        ' intercetto questo evento per fare in modo che il cursore si posizioni
        ' automaticamente sulla prima casella di testo
        txtCognome.Focus()

    End Sub


    Private Sub btnCancel_Click(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) _
                                Handles btnCancel.Click

        ' Click sul tasto "Annulla", esco senza salvare le modifiche
        Me.Close()

    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) _
                              Handles btnSave.Click

        ' Click sul tasto "Salva"

        ' Faccio dei controlli semplici sui campi

        ' Qui controllo che tutti e 3 i campi siano riempiti
        ' in pratica controllo che in ogni campo ci sia almeno un carattere
        ' (o almeno 7 caratteri per l'email)
        ' se non è così viene mostrato un messaggio di avvertimento ed
        ' esco dalla sub
        If txtCognome.Text.Trim.Length < 1 Or _
            txtNome.Text.Trim.Length < 1 Or _
            txtEmail.Text.Trim.Length < 7 Then

            MessageBox.Show("Uno o più campi sono stati lasciati vuoti", "Errore", _
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

            Exit Sub

        End If

        ' Qui controllo in maniera molto semplice l'indirizzo di posta.
        ' In pratica verifico che ci sia almeno il simbolo della chiocciola
        ' e il punto. Ovviamente questo controllo è molto grossolano e va
        ' sicuramente migliorato, ma per un'applicazione d'esempio va bene
        If txtEmail.Text.IndexOf("@") = -1 Or txtEmail.Text.IndexOf(".") = -1 Then

            MessageBox.Show("L'indirizzo E-Mail non è valido", "Errore", _
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

            ' Do il focus sulla textbox dell' e-mail
            txtEmail.Focus()

            Exit Sub

        End If

        ' Se siamo arrivati a questo punto vuol dire che tutti i controlli
        ' sono andati a buon fine, controllo quindi il valore di IdDaModificare
        ' perchè se vale -1 devo fare una Query di inserimento, se ha un valore
        ' diverso da -1, devo fare una Query di aggiornamento

        Dim Query As String = "" ' Stringa contenente la Query

        Select Case IdDaModificare

            Case -1 ' Record nuovo, query di inserimento

                ' Da notare:
                ' per ogni campo rimpiazzio eventuali apici (')
                ' con doppi apici ('') per evitare problemi nella query
                ' dal momento che i campi di testo vengono racchiusi
                ' tra apici. Ovviamente anzichè fare il replace ogni volta
                ' sarebbe più opportuno creare una funzione apposita
                Query = "INSERT INTO indirizzi (nome,cognome,email) VALUES (" & _
                        "'" & Replace(txtNome.Text.Trim, "'", "''") & "'," & _
                        "'" & Replace(txtCognome.Text.Trim, "'", "''") & "'," & _
                        "'" & Replace(txtEmail.Text.Trim.ToLower, "'", "''") & "')"


            Case Else ' Record modificato, query di aggiornamento

                ' Idem come sopra, rimpiazzo apici con doppi apici
                Query = "UPDATE indirizzi SET " & _
                        "nome='" & Replace(txtNome.Text.Trim, "'", "''") & "'," & _
                        "cognome='" & Replace(txtCognome.Text.Trim, "'", "''") & "'," & _
                        "email='" & Replace(txtEmail.Text.Trim, "'", "''") & "'" & _
                        "WHERE ID=" & IdDaModificare

        End Select

        ' Mi collego al database e stabilisco la connessione
        Dim Connessione As New FbConnection(Str_Co)
        Connessione.Open()

        ' Definisco una variabile che mi servirà a memorizzare
        ' il risultato della Query
        Dim Risultato As Integer = 0

        ' Racchiudo l'esecuzione della Query in un blocco Try - Catch
        ' per intercettare eventuali eccezioni
        Try

            ' Definisco un comando
            ' Tale comando deve eseguire la mia Query
            Dim Comando As New FbCommand(Query, Connessione)

            ' Eseguo il comando e ne memorizzo il valore di ritorno
            Risultato = Comando.ExecuteNonQuery

        Catch ex As Exception ' Catturo un'eventuale eccezione

            MessageBox.Show("Query fallita: " & vbCrLf & Query & vbCrLf & "Eccezione:" & _
                            vbCrLf & ex.ToString, "Errore", MessageBoxButtons.OK, _
                            MessageBoxIcon.Error)

        End Try

        ' Chiudo la connessione
        Connessione.Close()

        ' Se l'esecuzione del comando ha restituito zero come
        ' risultato, mostro un messaggio
        If Risultato = 0 Then

            MessageBox.Show("La Query non è andata a buon fine", "Errore", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

        ' Esco da questo form, e ritorno al principale
        Me.Close()

    End Sub

    Private Sub frmEdit_FormClosed(ByVal sender As Object, _
                                   ByVal e As System.Windows.Forms.FormClosedEventArgs) _
                                   Handles Me.FormClosed

        ' Sull'evento di chiusura del form, ne rilascio tutte le risorse
        ' questo serve ad evitare che ad un secondo richiamo, i campi del form
        ' rimangano compilati con i dati precedenti
        Me.Dispose()

    End Sub


End Class